import React, { useCallback, useState } from 'react';
import { Box, Popover, Table, TableBody, TableCell, TableContainer, TableRow, Typography } from '@mui/material';
import ForceDirectedGraph from './ForceDirectedGraph';
var STYLES = {
  popover: {
    pointerEvents: 'none'
  }
};
var DEFAULT_CONTAINER_HEIGHT = window.innerHeight / 2 - 40;
export function GraphWithTooltip(_ref) {
  var data = _ref.data,
    nodeCharge = _ref.nodeCharge,
    containerHeight = _ref.containerHeight;
  var _useState = useState(null),
    anchorEl = _useState[0],
    setAnchorEl = _useState[1];
  var _useState2 = useState(null),
    hoveredNode = _useState2[0],
    setHoveredNode = _useState2[1];
  var onMouseOverNode = useCallback(function (data) {
    setHoveredNode(data);
    setAnchorEl(this);
  }, []);
  return /*#__PURE__*/React.createElement(Box, null, /*#__PURE__*/React.createElement(ForceDirectedGraph, {
    data: data,
    containerHeight: containerHeight !== null && containerHeight !== void 0 ? containerHeight : DEFAULT_CONTAINER_HEIGHT,
    onMouseOverNode: onMouseOverNode,
    onMouseOutNode: function onMouseOutNode() {
      return setAnchorEl(null);
    },
    nodeCharge: nodeCharge
  }), /*#__PURE__*/React.createElement(Popover, {
    id: "mouse-over-popover",
    disableScrollLock: true,
    sx: STYLES.popover,
    open: Boolean(anchorEl),
    anchorEl: anchorEl,
    onClose: function onClose() {
      return setAnchorEl(null);
    },
    disableRestoreFocus: true,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: 'center'
    },
    transformOrigin: {
      vertical: 'top',
      horizontal: 'center'
    }
  }, /*#__PURE__*/React.createElement(TableContainer, null, /*#__PURE__*/React.createElement(Table, {
    size: "small"
  }, /*#__PURE__*/React.createElement(TableBody, null, /*#__PURE__*/React.createElement(TableRow, null, /*#__PURE__*/React.createElement(TableCell, {
    size: "small"
  }, /*#__PURE__*/React.createElement("b", null, "Peer ID")), /*#__PURE__*/React.createElement(TableCell, {
    size: "small"
  }, hoveredNode && hoveredNode.id + " (" + hoveredNode.pseudonym + ")")), /*#__PURE__*/React.createElement(TableRow, null, /*#__PURE__*/React.createElement(TableCell, {
    size: "small"
  }, /*#__PURE__*/React.createElement("b", null, "Multiaddr")), /*#__PURE__*/React.createElement(TableCell, {
    size: "small"
  }, hoveredNode && hoveredNode.multiaddrs.map(function (multiaddr) {
    return /*#__PURE__*/React.createElement(Typography, {
      key: multiaddr,
      variant: "body2"
    }, multiaddr);
  }))))))));
}