import React, { useCallback, useState } from 'react';
import { Box, Button, FormControl, InputLabel, MenuItem, Select } from '@mui/material';
import { CustomRelayDialog } from './CustomRelayDialog';
var STYLES = {
  primaryRelaySelect: {
    marginRight: 1,
    minWidth: 200
  }
};
export function PrimaryRelaySelector(_ref) {
  var _localStorage$getItem, _localStorage$getItem2;
  var _ref$relayNodes = _ref.relayNodes,
    relayNodes = _ref$relayNodes === void 0 ? [] : _ref$relayNodes;
  var _useState = useState(false),
    openCustomRelayDialog = _useState[0],
    setOpenCustomRelayDialog = _useState[1];
  var _useState2 = useState((_localStorage$getItem = localStorage.getItem('primaryRelay')) !== null && _localStorage$getItem !== void 0 ? _localStorage$getItem : ''),
    primaryRelay = _useState2[0],
    setPrimaryRelay = _useState2[1];
  var _useState3 = useState(localStorage.getItem('customRelay')),
    customRelay = _useState3[0],
    setCustomRelay = _useState3[1];
  var handlePrimaryRelaySelectChange = useCallback(function (event) {
    // Check if value is null when custom relay option is selected
    if (event.target.value !== null) {
      setPrimaryRelay(event.target.value);
    }
  }, []);
  var handleCustomOptionClick = useCallback(function (event) {
    setOpenCustomRelayDialog(true);
  }, []);

  // TODO: Handle primary relay update outside debug component?
  var handlePrimaryRelayUpdate = useCallback(function () {
    // Set selected primary relay in localStorage and refresh app
    localStorage.setItem('primaryRelay', primaryRelay);
    window.location.reload(false);
  }, [primaryRelay]);
  var handleCustomRelaySet = useCallback(function (newCustomRelay) {
    setCustomRelay(newCustomRelay);
    // Set custom relay in localStorage
    localStorage.setItem('customRelay', newCustomRelay);
    setPrimaryRelay(newCustomRelay);
    setOpenCustomRelayDialog(false);
  }, []);
  var handleCustomRelayCancel = useCallback(function () {
    setPrimaryRelay(primaryRelay);
    setOpenCustomRelayDialog(false);
  }, [primaryRelay]);
  return /*#__PURE__*/React.createElement(Box, {
    display: "flex",
    alignItems: "flex-end"
  }, /*#__PURE__*/React.createElement(FormControl, {
    variant: "standard",
    sx: STYLES.primaryRelaySelect,
    size: "small"
  }, /*#__PURE__*/React.createElement(InputLabel, {
    shrink: true,
    id: "primary-relay-label"
  }, "Primary Relay"), /*#__PURE__*/React.createElement(Select, {
    displayEmpty: true,
    labelId: "primary-relay-label",
    id: "primary-label",
    value: primaryRelay,
    label: "Primary Relay",
    onChange: handlePrimaryRelaySelectChange
  }, /*#__PURE__*/React.createElement(MenuItem, {
    value: ""
  }, "<random>"), relayNodes.map(function (relayNode) {
    return /*#__PURE__*/React.createElement(MenuItem, {
      value: relayNode,
      key: relayNode
    }, relayNode.split('/')[2]);
  }), /*#__PURE__*/React.createElement(MenuItem, {
    value: customRelay,
    onClick: handleCustomOptionClick
  }, "<custom>"))), /*#__PURE__*/React.createElement(Button, {
    variant: "contained",
    size: "small",
    disabled: primaryRelay === ((_localStorage$getItem2 = localStorage.getItem('primaryRelay')) !== null && _localStorage$getItem2 !== void 0 ? _localStorage$getItem2 : ''),
    onClick: handlePrimaryRelayUpdate
  }, "UPDATE"), /*#__PURE__*/React.createElement(CustomRelayDialog, {
    open: openCustomRelayDialog,
    oldCustomRelay: customRelay,
    onSet: handleCustomRelaySet,
    onCancel: handleCustomRelayCancel
  }));
}