"use strict";

exports.__esModule = true;
exports.PrimaryRelaySelector = PrimaryRelaySelector;
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _CustomRelayDialog = require("./CustomRelayDialog");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var STYLES = {
  primaryRelaySelect: {
    marginRight: 1,
    minWidth: 200
  }
};
function PrimaryRelaySelector(_ref) {
  var _localStorage$getItem, _localStorage$getItem2;
  var _ref$relayNodes = _ref.relayNodes,
    relayNodes = _ref$relayNodes === void 0 ? [] : _ref$relayNodes;
  var _useState = (0, _react.useState)(false),
    openCustomRelayDialog = _useState[0],
    setOpenCustomRelayDialog = _useState[1];
  var _useState2 = (0, _react.useState)((_localStorage$getItem = localStorage.getItem('primaryRelay')) !== null && _localStorage$getItem !== void 0 ? _localStorage$getItem : ''),
    primaryRelay = _useState2[0],
    setPrimaryRelay = _useState2[1];
  var _useState3 = (0, _react.useState)(localStorage.getItem('customRelay')),
    customRelay = _useState3[0],
    setCustomRelay = _useState3[1];
  var handlePrimaryRelaySelectChange = (0, _react.useCallback)(function (event) {
    // Check if value is null when custom relay option is selected
    if (event.target.value !== null) {
      setPrimaryRelay(event.target.value);
    }
  }, []);
  var handleCustomOptionClick = (0, _react.useCallback)(function (event) {
    setOpenCustomRelayDialog(true);
  }, []);

  // TODO: Handle primary relay update outside debug component?
  var handlePrimaryRelayUpdate = (0, _react.useCallback)(function () {
    // Set selected primary relay in localStorage and refresh app
    localStorage.setItem('primaryRelay', primaryRelay);
    window.location.reload(false);
  }, [primaryRelay]);
  var handleCustomRelaySet = (0, _react.useCallback)(function (newCustomRelay) {
    setCustomRelay(newCustomRelay);
    // Set custom relay in localStorage
    localStorage.setItem('customRelay', newCustomRelay);
    setPrimaryRelay(newCustomRelay);
    setOpenCustomRelayDialog(false);
  }, []);
  var handleCustomRelayCancel = (0, _react.useCallback)(function () {
    setPrimaryRelay(primaryRelay);
    setOpenCustomRelayDialog(false);
  }, [primaryRelay]);
  return /*#__PURE__*/_react["default"].createElement(_material.Box, {
    display: "flex",
    alignItems: "flex-end"
  }, /*#__PURE__*/_react["default"].createElement(_material.FormControl, {
    variant: "standard",
    sx: STYLES.primaryRelaySelect,
    size: "small"
  }, /*#__PURE__*/_react["default"].createElement(_material.InputLabel, {
    shrink: true,
    id: "primary-relay-label"
  }, "Primary Relay"), /*#__PURE__*/_react["default"].createElement(_material.Select, {
    displayEmpty: true,
    labelId: "primary-relay-label",
    id: "primary-label",
    value: primaryRelay,
    label: "Primary Relay",
    onChange: handlePrimaryRelaySelectChange
  }, /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    value: ""
  }, "<random>"), relayNodes.map(function (relayNode) {
    return /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
      value: relayNode,
      key: relayNode
    }, relayNode.split('/')[2]);
  }), /*#__PURE__*/_react["default"].createElement(_material.MenuItem, {
    value: customRelay,
    onClick: handleCustomOptionClick
  }, "<custom>"))), /*#__PURE__*/_react["default"].createElement(_material.Button, {
    variant: "contained",
    size: "small",
    disabled: primaryRelay === ((_localStorage$getItem2 = localStorage.getItem('primaryRelay')) !== null && _localStorage$getItem2 !== void 0 ? _localStorage$getItem2 : ''),
    onClick: handlePrimaryRelayUpdate
  }, "UPDATE"), /*#__PURE__*/_react["default"].createElement(_CustomRelayDialog.CustomRelayDialog, {
    open: openCustomRelayDialog,
    oldCustomRelay: customRelay,
    onSet: handleCustomRelaySet,
    onCancel: handleCustomRelayCancel
  }));
}