"use strict";

exports.__esModule = true;
exports.TabPanel = TabPanel;
var _react = _interopRequireWildcard(require("react"));
var _TabContext = require("@mui/lab/TabContext");
var _material = require("@mui/material");
var _excluded = ["children", "value"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// Custom TabPanel component to keep mounted after switching to other tab
function TabPanel(_ref) {
  var children = _ref.children,
    id = _ref.value,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var context = (0, _TabContext.useTabContext)();
  var _useState = (0, _react.useState)(false),
    visited = _useState[0],
    setVisited = _useState[1];
  if (context === null) {
    throw new TypeError("No TabContext provided");
  }
  var tabId = context.value;
  (0, _react.useEffect)(function () {
    if (id === tabId) {
      setVisited(true);
    }
  }, [id, tabId]);
  return /*#__PURE__*/_react["default"].createElement(_material.Box, _extends({
    hidden: id !== tabId
  }, props), visited && children);
}